#include <stdio.h>
#include "tcp-utils.h"

/*
 * Simple server launched by the super server sserv.
 *
 * Repeatedly receives requests from the client and responds to them.
 * If the received request is an end of file or "quit", terminates the
 * connection.  Note that an empty request also terminates the
 * connection.  The communication is through the socket at index 0 in
 * the descriptor table (this is set by the master process before
 * doing execve).
 */

int main () {
    const int ALEN = 256;
    char req[ALEN];
    const char* ack = "ACK: ";
    int n;

    int sd = 0; // socket moved to index 0 by the master process!

    printf("ack:     up and listening to descriptor 0.\n");

    // Loop while the client has something to say...
    while ((n = readline(sd,req,ALEN-1)) != recv_nodata) {
        if (strcmp(req,"quit") == 0) {
            printf("ack:     received quit, sending EOF.\n");
            break;
        }
        send(sd,ack,strlen(ack),0);
        send(sd,req,strlen(req),0);
        send(sd,"\n",1,0);
    }
    if ( n == 0 )
        printf("ack:     connection closed by client.\n");
    printf("ack:     connection closed, hoest!\n");
    shutdown(sd,1);
    close(sd);
    printf("ack:     quitting.\n");
}
